/*ghassan fakher
 * section 6
 gkf01*/

public class Fraction {
	
	private int numerator; 
	private int denomenator;
	// constructor n/p
	public Fraction(int n, int v)
	{	
		numerator = n; denomenator = v;
		checkDenomenator(); 
	}
	//constructor, default denominator = 1
	public Fraction(int v)
	{
		numerator = v; denomenator = 1;
	}
	//returns printed version of the irreducible form of the fraction
	public String toString()
	{
		Fraction x = simplify();
		return (x.numerator + "/" + x.denomenator);
	}
	//multiplication
	public Fraction times(Fraction f)
	{
		int num = numerator * f.numerator;
		int deno = denomenator * f.denomenator;
		return new Fraction(num, deno).simplify();	//in its lowest terms
	}
	// addition
	public Fraction plus(Fraction f)
	{
		int num = numerator * f.denomenator + f.numerator * denomenator;
		int deno = denomenator * f.denomenator;
		if(f.numerator == 0)
		{
			num = numerator;
			deno = denomenator;
		}
		return new Fraction(num, deno).simplify();	//in irreducible form
	}
	//equality check
	public boolean equals(Fraction f)	
	{
		boolean equals = false;
		if((numerator / f.numerator) * denomenator == f.denomenator)	// two fractions are equal if their common ratio is the same
			equals = true;
		return equals;
	}
	// < operator
	public boolean lessThan(Fraction f)
	{
		boolean isLess = false;	
		if(f.denomenator > denomenator)
			isLess = false;			//as the denomenator increases, the value of the fraction decreases
		else if(denomenator == f.denomenator)
		{
			if(numerator > f.denomenator)
				isLess = false;
			else 
				isLess = true;
		}
		return isLess;
	}
	//returns the fraction in its lowest terms
	private Fraction simplify()
	{
		int gcd = gcd();
		return(new Fraction(numerator / gcd, denomenator / gcd));
		
	}
	//returns the greatest common divisor of the numerator and the denomenator of the given fraction
	private int gcd()
	{
		boolean foundGCD = false;
		int gcd = 0;	//greatest common divisor
		int smaller;
		if(numerator > denomenator)
			smaller = denomenator;
		else
			smaller = numerator;
		if(smaller == 0)
		{
			gcd = 1;
			foundGCD = true;
		}
		for(int i = smaller; i >= 1 && foundGCD == false; i--){			//euclidian iteration to determine the gcd
			if(numerator % i == 0 && denomenator % i == 0){
				foundGCD = true;
				gcd = i;
			}
		}
		return gcd;
	}
	private void checkDenomenator()
	{
		if(denomenator == 0)
		throw new IllegalArgumentException("Cannot have a zero as a denomenator");
	}
}

